﻿using System;

using Android.App;
using Android.Content.PM;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Android.Support.V4.App;
using Android;
using AndroidX.Core.App;
using Android.Content;
using Xamarin.Forms.Internals;
using Woyou.Aidlservice.Jiuiv5;

namespace SDKuDemo.Droid
{
    [Activity(Label = "SDKuDemo", Icon = "@mipmap/icon", Theme = "@style/MainTheme", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation | ConfigChanges.UiMode | ConfigChanges.ScreenLayout | ConfigChanges.SmallestScreenSize)]
    public class MainActivity : global::Xamarin.Forms.Platform.Android.FormsAppCompatActivity
    {
        public static MainActivity SharedController = null;
        private WoyouServiceConnection _serviceConnection;

        public IWoyouService Service { get; set; }

        public bool IsBound { get; set; }

        protected override void OnCreate(Bundle savedInstanceState)
        {
            TabLayoutResource = Resource.Layout.Tabbar;
            ToolbarResource = Resource.Layout.Toolbar;

            Xamarin.IDTech.AndroidBinding.IDTechBinding.Init(this);

            SharedController = this;

            base.OnCreate(savedInstanceState);
  
            Xamarin.Essentials.Platform.Init(this, savedInstanceState);
            global::Xamarin.Forms.Forms.Init(this, savedInstanceState);
            LoadApplication(new App());
            this.RequestPermissions(new[]
            {
                Manifest.Permission.AccessCoarseLocation,
                Manifest.Permission.AccessFineLocation,
                Manifest.Permission.AccessNetworkState,
                Manifest.Permission.BluetoothPrivileged,
                Manifest.Permission.Bluetooth,
                Manifest.Permission.BluetoothAdmin,
                Manifest.Permission.ModifyAudioSettings,
                Manifest.Permission.RecordAudio
            }, 0);
            Xamarin.IDTech.AndroidBinding.IDTechBinding.enableUSB();
            InitService();
        }
        public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
        {
            Xamarin.Essentials.Platform.OnRequestPermissionsResult(requestCode, permissions, grantResults);

            base.OnRequestPermissionsResult(requestCode, permissions, grantResults);
        }

        private void InitService()
        {
            _serviceConnection = new WoyouServiceConnection(this);
            var additionServiceIntent = new Intent();
            additionServiceIntent.SetPackage("woyou.aidlservice.jiuiv5");
            additionServiceIntent.SetAction("woyou.aidlservice.jiuiv5.IWoyouService");
            _serviceConnection = new WoyouServiceConnection(this);
            ApplicationContext.BindService(additionServiceIntent, _serviceConnection, Bind.AutoCreate);
        }

        public void ReleaseService()
        {
            if (IsBound)
            {
                ApplicationContext.UnbindService(_serviceConnection);
                IsBound = false;
                _serviceConnection = null;
            }
        }


    }
}